from PyQt4.QtCore import *
from PyQt4.QtGui import *

class FullCompleter(QCompleter):
    """Complete based on substring."""
    def __init__(self, parent, combo):
        QCompleter.__init__(self, parent)

        self.setCompletionMode(QCompleter.PopupCompletion)

        self.proxymodel = QSortFilterProxyModel(self)
        self.proxymodel.setSourceModel(combo.model())
        self.setModel(self.proxymodel)

    def splitPath(self, path):
        self.proxymodel.setFilterRegExp(QRegExp(
            path, Qt.CaseInsensitive,
            QRegExp.FixedString))
        return ['']

def main():
    app = QApplication([])

    combo = QComboBox()
    combo.addItems(['hello', 'world', 'world hello', 'hello world'])
    combo.setEditable(True)
    combo.show()

    completer = FullCompleter(combo, combo)
    combo.setCompleter(completer)

    app.exec_()

    #combo.setCompleter(None)
    #completer = None

if __name__ == '__main__':
    main()
